local toc, data = ...
local id = toc.identifier

local player = ""
local inCombat = false

local startMsg = "Gadgets: MoveNow enabled, type /mnStop to disable"
local stopMsg = "Gadgets: MoveNow disabled, type /mnStart to enable"

local rgbRed = { r = .75, g = .25, b = .25, a = .9,
                fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbGreen = { r = .25, g = .75, b = .25, a = .9,
                  fr = .1 ,fg = .1 ,fb = .1 ,fa = 1 }
local rgbBlue = { r = .25, g = .25, b = .75, a = .9,
                 fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbPurple = { r =   0.676, g =   0.281, b =    0.98, a = .9,
                 fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbYellow = { r = 1  , g = .96, b = .41, a = .9,
                   fr = .1 ,fg = .1 ,fb = .1 ,fa = 1 }

local RED = "RED"
local GREEN = "GREEN"
local BLUE = "BLUE"
local YELLOW = "YELLOW"
local PURPLE = "PURPLE"

local LEFT = "LEFT"
local RIGHT = "RIGHT"
local FORWARD = "FORWARD"
local BACK = "BACK"
local AWAY = "AWAY"

local gMN = {
    Zaviel = { loc = "Tempest Engine" },
    Matriarch = { loc = "Halls of Decay" },
}
gMN.Zaviel.track = false
gMN.Zaviel.movemovemove = { name = "Hot Foot", dir = AWAY, color = PURPLE}

gMN.Matriarch.track = true
gMN.Matriarch.necrotic = { name = "Necrotic Spores", dir = "MOVE MOVE MOVE!", color = GREEN}
gMN.Matriarch.infection = { name = "Volatile Infection", dir = "STOP EVERYTHING", color = RED}

local messageActive = false
local messageBuffID = ""

local wykkydGMNReady      = 0

local gmnWindows = {}

local function moveTo(wrn, dir, prn, bg)
    if bg == RED then
        c = rgbRed
    elseif bg == GREEN then
        c = rgbGreen
    elseif bg == BLUE then
        c = rgbBlue
    elseif bg == YELLOW then
        c = rgbYellow
    elseif bg == PURPLE then
        c = rgbPurple
    end
    if dir == LEFT then
        a = "<< "..wrn
    elseif dir == RIGHT then
        a = wrn.." >>"
    elseif dir == FORWARD then
        a = "^ "..wrn.." ^"
    elseif dir == BACK then
        a = "v "..wrn.." v"
    elseif dir == AWAY then
        a = "<< "..wrn.." >>"
    else a = dir; prn = dir;
    end
    for _, win in pairs(gmnWindows) do
        win:SetFontColor( c.fr, c.fg, c.fb, c.fa )
        win:SetBackgroundColor( c.r, c.g, c.b, c.a )
        win:SetText( a )
    end
    messageActive = true
    print( prn )
end

local function clearMessage()
    messageActive = false
    messageBuffID = ""
    for _, win in pairs(gmnWindows) do
        win:SetBackgroundColor( 0.0, 0.0, 0.0, 0.0)
        win:SetText("")
    end
end

local function checkbuffSpecific(unit, buff, compare, dir, color)
    if buff.type == compare or buff.name == compare then
        if messageActive == false then
            moveTo( "MOVE "..dir, dir, "Move "..dir.." ( "..buff.name.." )", color )
        end 
        return true
    end
    return false
end

local function tryCheckBuff(unit, buff, compare, dir, color)
    local details = Inspect.Buff.Detail(unit, buff)
    if details then
        return checkbuffSpecific(unit, details, compare, dir, color)
    else
        return false
    end
end

local curUnit = nil

local function checkPrecise(buff)
    if Inspect.System.Secure() then
        local hasBuff = false 
        local unit = "player"
        curUnit = Inspect.Unit.Detail("player")
        local p = curUnit
        if p.locationName == gMN.Zaviel.loc then 
            if not gMN.Zaviel.track then return end
        elseif p.locationName == gMN.Matriarch.loc then
            if not gMN.Matriarch.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, gMN.Matriarch.necrotic.name, gMN.Matriarch.necrotic.dir, gMN.Matriarch.necrotic.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, gMN.Matriarch.infection.name, gMN.Matriarch.infection.dir, gMN.Matriarch.infection.color); if hasBuff then return end; end
        else return end
        if hasBuff == false then clearMessage() end
    end
end

local function gmnCleanup(details)
    for u, b in pairs(details) do
        if u == player then
            if b then 
                curUnit = Inspect.Unit.Detail("player")
            else
                clearMessage()
            end
        end
    end
end
local function gmnUpdate(unit, updates)
    if wykkydGMNReady == 0 then return end
    if messageActive then return end
    messageBuffID = ""
    if unit == player then 
        for buff, bool in pairs(updates) do 
            checkPrecise(buff) 
            if messageActive then messageBuffID = buff end
        end
    end
end
local function gmnSoftUpdate(unit, updates)
    if wykkydGMNReady == 0 then return end
    if not messageActive then return end
    if unit == player then 
        for buff, bool in pairs(updates) do 
            if messageBuffID == buff then
                clearMessage()
            end
        end
    end
end

local function cycle(n)
    wykkydGMNReady = n
    clearMessage()
    messageActive = false
    messageBuffID = ""
    for _, win in pairs(gmnWindows) do
        win:SetBackgroundColor(0.0,0.0,0.0,0.0)
        win:SetText("")
    end
end
local function mnStart() cycle(1); print(startMsg); end
local function mnStop() cycle(0); print(stopMsg); end

local function Create(configuration)
    local u = Inspect.Unit.Lookup("player")
    player = u
        
	local wykkydGMNPanel = UI.CreateFrame("Frame", WT.UniqueName("Wykkyd.MoveNow"), WT.Context)
	wykkydGMNPanel:SetWidth(340)
	wykkydGMNPanel:SetHeight(50)
	wykkydGMNPanel:SetBackgroundColor(0,0,0,0.0)
    
	local gmnFrame = UI.CreateFrame("Text", WT.UniqueName("Wykkyd.MoveNow"), wykkydGMNPanel)
	gmnFrame:SetText("")
	gmnFrame:SetFontSize(40)
	gmnFrame.currText = ""
    
	gmnFrame:SetPoint("TOPCENTER", wykkydGMNPanel, "TOPCENTER", 0, 0)
        
	table.insert(gmnWindows, gmnFrame)
    table.insert(Event.Buff.Add,{gmnUpdate, "Gadgets_MoveNow", "gmnUpdate" })
    table.insert(Event.Buff.Remove,{gmnSoftUpdate, "Gadgets_MoveNow", "gmnSoftUpdate" })
    table.insert(Command.Slash.Register("mnReset"),  {gmnCleanup,  "Gadgets_MoveNow", "mnReset"} )
    table.insert(Command.Slash.Register("mnStop"),  {mnStop,  "Gadgets_MoveNow", "mnStop"} )
    table.insert(Command.Slash.Register("mnStart"), {mnStart, "Gadgets_MoveNow", "mnStart"})
    mnStart()
	return wykkydGMNPanel, { resizable={340, 50, 340, 50} }
end

local dialog = false

local function ConfigDialog(container)
	dialog = WT.Dialog(container)
		:Label("Currently there are no config options.")
end

local function GetConfiguration() return dialog:GetValues() end

local function SetConfiguration(config) dialog:SetValues(config) end

WT.Gadget.RegisterFactory("wykkydMoveNow", {
		name="MoveNow Panel",
		description="Small window that tells you to move",
		author=toc.toc.Author,
		version=toc.toc.Version,
		["Create"] = Create,
		["ConfigDialog"] = ConfigDialog,
		["GetConfiguration"] = GetConfiguration, 
		["SetConfiguration"] = SetConfiguration, 
	})
 